#ifndef __SYMMETRY_H
#define __SYMMETRY_H 1

#include "config.h"
/* #include "spins.h" */

/* test and if neccessary create up to num symmetries P */

/* --- ABEL(NOABEL) Nutzung abelscher(nichtabelscher) Symmetriegruppe --- */
#if !defined(CONFIG_NOABEL) && !defined(CONFIG_ABEL)
#define CONFIG_NOABEL 1		/* CONFIG_ABEL or CONFIG_NOABEL */
#endif

/* --- S1SYM - besondere Behandlung der Spin-1 ((n>1)/2) Symmetrie --- */
#if !defined(CONFIG_S1SYM) && !defined(CONFIG_NOS1SYM)
#if NN>8*0			/* nur bei grossen Systemen schneller */
#define CONFIG_S1SYM  1		/* CONFIG_S1SYM or CONFIG_NOS1SYM */
#else
#define CONFIG_NOS1SYM  1	/* CONFIG_S1SYM or CONFIG_NOS1SYM */
#endif
#endif
/*
 *  CONFIG_S1SYM useful for spin-1 systems with a lot of symmetries
 *             - does reduce the time needed for scanning for symmetries
 *             - this option should vanish in later versions (js Okt.98)
 */

#ifndef MaxSym
#define MaxSym   (4100)      /* ToDo: change to dynamic allocation */
#error MaxSym not defined
#endif

/* to store arrays of site numbers, we take smallest possible type */
#if NN<128
// #warning change back
typedef signed char  t_sites;    /* better for size */
// typedef int t_sites; /* ToDo: better for speed (if int array fits cache) */
#elif NN<32768
typedef signed short t_sites;
#else
typedef int t_sites;
#endif
#if VecType & 4				/* new 1998-166 JS */
/* typedef Complex     tphase; */       /* exp(I*2*Pi*k/l) */
typedef cplx     tphase;		/* exp(I*2*Pi*k/l) */
#else
typedef signed char tphase;		/* only -1 or +1 possible */
#endif
/*  --- int=4*char usually signed/unsigned? pc-specifisch! 
    --- evl. tsym.w als array[k][l] zum speicher sparen
    --- large struct!!! do not use as local variable! Nov99
 */
#define MaxNumSL 8  /* maximum number of sublattice configurations (j1,..) */
struct tsym {				/* Symmetrien	*/
  int	init,numsym,numall,             /*  ini,Sym,1<<Sym      */
        wud;                            /*  wud=+1,0=no,-1 ToDo: kud= -1=no,0,1      */
  t_sites i[MaxSym][NN];		/*  Permutation j->i[j]	*/
  t_sites k[MaxSym];                    /*  k => exp(i*2Pi*k)	*/
  tphase  w[MaxSym];                    /*  weight exp(i*2Pi*k)=1,-1 l=2 or 0 */
  t_sites l[MaxSym];                    /*  cycle length k = 0,1,2,..,l-1 */
  char    g[MaxSym];                    /*  1 = generators of sym-group */
  t_sites lm[NN];			/* lm-group idx */
  t_sites li[NN];			/* index within lm-group */
  t_sites ls[NN];			/* size of lm-group */
  t_sites ln[NN];			/* point to next lm-member v2.21 */
  t_sites lp[NN];			/* point to prev lm-member v2.44 */
  t_sites num_lm;			/*  number of spins (max(lm)+1) */
  int     corr[NN][NN];			/* array of sym. pair correlations */
  t_sites dcorr[NN*NN][2];		/* different pair correlations */
  int   num_dcorr;			/* number of -//- (0..NN*(NN-1)) */
  /* used for the Marshall rule and SL-magnetization */
  int   subl;				/* sublattice number 0..MaxNumSL-1 */
  int   sl[MaxNumSL][NN];		/* sublattice index ABAB AABB ... */
  
  int   inverse[MaxSym];		/* point to P^(-1) */
  int   kgen[MaxSym];			/* Vorgaben k fuer Generatoren */
};

extern struct tsym sym;

int symcreate(int mpi_i);
int test_all_sym();

#endif
